| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Static Public Member Functions | Properties | List of all members
IG.Num.MExt Class Reference

Defines some mathematical functions to be used in derived classes. In addition to functions defined in the M class, functions are defined under other names, and some additional functions are also defined. More...

Inheritance diagram for IG.Num.MExt:
[legend]
Collaboration diagram for IG.Num.MExt:
[legend]

## Static Public Member Functions
static double | Abs (double a)
| Absolute value. More...
static double | Sign (double a)
| Returns a value indicating the sign of a number. More...
static double | sgn (double a)
| Returns a value indicating the sign of a number. More...
static double | Ceiling (double a)
| Returns the smallest integral value that is greater than or equal to the specified decimal number. More...
static double | ceiling (double a)
| Returns the smallest integral value that is greater than or equal to the specified decimal number. More...
static double | Floor (double a)
| Returns the largest integer less than or equal to the specified number. More...
static double | Truncate (double a)
| Calculates the integral part of a specified double-precision floating-point number. More...
static double | truncate (double a)
| Calculates the integral part of a specified number. More...
static double | Min (double a, double b)
| Smallest of two numbers. More...
static double | Max (double a, double b)
| Largest of two numbers. More...
static double | Min (double a, double b, double c)
| Smallest of three numbers. More...
static double | Max (double a, double b, double c)
| Largest of three numbers. More...
static double | Min (double a, double b, double c, double d)
| Smallest of four numbers. More...
static double | Max (double a, double b, double c, double d)
| Largest of four numbers. More...
static double | Min (double a, double b, double c, double d, double e)
| Smallest of five numbers. More...
static double | Max (double a, double b, double c, double d, double e)
| Largest of five numbers. More...
static double | Min (double a, double b, double c, double d, double e, double f)
| Smallest of six numbers. More...
static double | Max (double a, double b, double c, double d, double e, double f)
| Largest of six numbers. More...
static double | Min (params double[] numbers)
| Minimal of the specified values. More...
static double | Max (params double[] numbers)
| Maximal of the specified values. More...
static double | Sum (params double[] numbers)
| Sum of the specified values. More...
static double | Product (params double[] numbers)
| Product of the specified values. More...
static double | product (params double[] numbers)
| Product of the specified values. More...
static double | Pow (double a, double b)
| Returns a specified number raised to the specified power. More...
static double | Sqr (double a)
| Returns the square of a specified number. More...
static double | Cube (double a)
| Returns the square of a specified number. More...
static double | Pow2 (double x)
| Square. More...
static double | Pow3 (double x)
| 3rd power. More...
static double | Pow4 (double x)
| 4th power. More...
static double | Pow5 (double x)
| 5th power. More...
static double | Pow6 (double x)
| 6th power. More...
static double | Sqrt (double a)
| Returns the square root of a specified number. More...
static double | Root2 (double a)
| Returns the square root of a specified number. More...
static double | Root3 (double a)
| Returns the cubic root of a specified number. More...
static double | Rand ()
| Returns a uniformly distributed random number greater than or equal to 0.0, and less or equal than 1.0. More...
static double | Rand (double min, double max)
| Returns a uniformly distributed random number greater than or equal to min, and less or equal than max. More...
static double | RandGauss (double mean, double standardDeviation)
| Returns a Gaussian distributed random number with the specified mean and standard deviation. More...
static double | Exp (double a)
| Returns e raised to the specified power. More...
static double | Log (double a)
| Returns the natural (base e) logarithm of a specified number. More...
static double | Log10 (double a)
| Returns the base 10 logarithm of a specified number. More...
static double | Log2 (double a)
| Returns the base 2 logarithm of a specified number. More...
static double | Log (double a, double logBase)
| Returns the logarithm of a specified number in a specified base. More...
static double | Degrees (double x)
| Converts angle in radians to angle in degrees and returns it. More...
static double | Radians (double x)
| Converts angle in degrees to angle in radians and returns it. More...
static double | Sin (double a)
| Returns the sine of the specified angle. More...
static double | Cos (double a)
| Returns the cosine of the specified angle. More...
static double | Tan (double a)
| Returns the tangent of the specified angle. More...
static double | tan (double a)
| Returns the tangent of the specified angle. More...
static double | Cot (double x)
| Returns cotangent of the specified angle. More...
static double | Acos (double a)
| Returns the angle whose cosine is the specified number. More...
static double | acos (double a)
| Returns the angle whose cosine is the specified number. More...
static double | Asin (double a)
| Returns the angle whose sine is the specified number. More...
static double | asin (double a)
| Returns the angle whose sine is the specified number. More...
static double | Atan (double a)
| Returns the angle whose tangent is the specified number. More...
static double | atan (double a)
| Returns the angle whose tangent is the specified number. More...
static double | arctan (double a)
| Returns the angle whose tangent is the specified number. More...
static double | Acot (double x)
| Arc cotangent, inverse of 1/tan(x). More...
static double | acot (double x)
| Arc cotangent, inverse of 1/tan(x). More...
static double | ArcCot (double x)
| Arc cotangent, inverse of 1/tan(x). More...
static double | arccot (double x)
| Arc cotangent, inverse of 1/tan(x). More...
static double | Atan2 (double a, double b)
| Returns the angle whose tangent is the quotient of two specified numbers. More...
static double | atan2 (double a, double b)
| Returns the angle whose tangent is the quotient of two specified numbers. More...
static double | arctan2 (double a, double b)
| Returns the angle whose tangent is the quotient of two specified numbers. More...
static double | Cosh (double a)
| Returns the hyperbolic cosine of the specified angle. More...
static double | cosh (double a)
| Returns the hyperbolic cosine of the specified angle. More...
static double | Tanh (double a)
| Returns the hyperbolic tangent of the specified angle. More...
static double | tanh (double a)
| Returns the hyperbolic tangent of the specified angle. More...
static double | Coth (double x)
| Hyperblic cotangent, 1/Math.Tanh. More...
static double | coth (double x)
| Hyperblic cotangent, 1/Math.Tanh. More...
static double | Arsinh (double x)
| Inverse hyperbolic sine. More...
static double | Arcosh (double x)
| Inverse hyperbolic cosine. More...
static double | Artanh (double x)
| Inverse hyperbolic tangent. More...
static double | Arcoth (double x)
| Inverse hyperbolic cotangent. More...
static long | Factorial (int factor)
| Returns factorial of the specified number. More...
static long | factorial (int factor)
| Returns factorial of the specified number. More...
static long | BinomialCoefficient (long n, long k)
| Returns binomial coefficient n over k . More...
Static Public Member Functions inherited from IG.Num.M
static void | Swap (ref double a, ref double b)
| Swaps values of the two specified variables of type double. More...
static void | Swap (ref int a, ref int b)
| Swaps values of the two specified variables of type int. More...
static void | Swap (ref string a, ref string b)
| Swaps values of the two specified variables of type string. More...
static double | abs (double a)
| Absolute value. More...
static double | sign (double a)
| Returns a value indicating the sign of a number. More...
static double | ceil (double a)
| Returns the smallest integral value that is greater than or equal to the specified decimal number. More...
static double | floor (double a)
| Returns the largest integer less than or equal to the specified number. More...
static double | trunc (double a)
| Calculates the integral part of a specified number. More...
static double | min (double a, double b)
| Smallest of two numbers. More...
static double | max (double a, double b)
| Largest of two numbers. More...
static double | min (double a, double b, double c)
| Smallest of three numbers. More...
static double | max (double a, double b, double c)
| Largest of three numbers. More...
static double | min (double a, double b, double c, double d)
| Smallest of four numbers. More...
static double | max (double a, double b, double c, double d)
| Largest of four numbers. More...
static double | min (double a, double b, double c, double d, double e)
| Smallest of five numbers. More...
static double | max (double a, double b, double c, double d, double e)
| Largest of five numbers. More...
static double | min (double a, double b, double c, double d, double e, double f)
| Smallest of six numbers. More...
static double | max (double a, double b, double c, double d, double e, double f)
| Largest of six numbers. More...
static double | min (params double[] numbers)
| Minimal of the specified values. More...
static double | max (params double[] numbers)
| Maximal of the specified values. More...
static double | sum (params double[] numbers)
| Sum of the specified values. More...
static double | prod (params double[] numbers)
| Product of the specified values. More...
static double | pow (double a, double b)
| Returns a specified number raised to the specified power. More...
static double | sqr (double a)
| Returns the square of a specified number. More...
static double | cube (double a)
| Returns the square of a specified number. More...
static double | pow2 (double x)
| Square. More...
static double | pow3 (double x)
| 3rd power. More...
static double | pow4 (double x)
| 4th power. More...
static double | pow5 (double x)
| 5th power. More...
static double | pow6 (double x)
| 6th power. More...
static double | sqrt (double a)
| Returns the square root of a specified number. More...
static double | root2 (double a)
| Returns the square root of a specified number. More...
static double | root3 (double a)
| Returns the cubic root of a specified number. More...
static double | rand ()
| Returns a uniformly distributed random number greater than or equal to 0.0, and less or equal than 1.0. More...
static double | rand (double min, double max)
| Returns a uniformly distributed random number greater than or equal to min, and less or equal than max. More...
static double | randgauss (double mean, double standardDeviation)
| Returns a Gaussian distributed random number with the specified mean and standard deviation. More...
static double | exp (double a)
| Returns e raised to the specified power. More...
static double | log (double a)
| Returns the natural (base e) logarithm of a specified number. More...
static double | ln (double a)
| Returns the natural (base e) logarithm of a specified number. More...
static double | log10 (double a)
| Returns the base 10 logarithm of a specified number. More...
static double | lg (double a)
| Returns the base 10 logarithm of a specified number. More...
static double | log2 (double a)
| Returns the base 2 logarithm of a specified number. More...
static double | log (double a, double logBase)
| Returns the logarithm of a specified number in a specified base. More...
static double | deg (double x)
| Converts angle in radians to angle in degrees and returns it. More...
static double | rad (double x)
| Converts angle in degrees to angle in radians and returns it. More...
static double | sin (double a)
| Returns the sine of the specified angle. More...
static double | cos (double a)
| Returns the cosine of the specified angle. More...
static double | tg (double a)
| Returns the tangent of the specified angle. More...
static double | ctg (double x)
| Returns cotangent of the specified angle. More...
static double | arccos (double a)
| Returns the angle whose cosine is the specified number. More...
static double | arcsin (double a)
| Returns the angle whose sine is the specified number. More...
static double | arctg (double a)
| Returns the angle whose tangent is the specified number. More...
static double | arcctg (double x)
| Arc cotangent, inverse of 1/tan(x). More...
static double | arctg2 (double a, double b)
| Returns the angle whose tangent is the quotient of two specified numbers. More...
static double | Sinh (double a)
| Returns the hyperbolic sine of the specified angle. More...
static double | sinh (double a)
| Returns the hyperbolic sine of the specified angle. More...
static double | sh (double a)
| Returns the hyperbolic sine of the specified angle. More...
static double | ch (double a)
| Returns the hyperbolic cosine of the specified angle. More...
static double | th (double a)
| Returns the hyperbolic tangent of the specified angle. More...
static double | cth (double x)
| Hyperblic cotangent, 1/Math.Tanh. More...
static double | arsh (double x)
| Inverse hyperbolic sine. More...
static double | arch (double x)
| Inverse hyperbolic cosine. More...
static double | arth (double x)
| Inverse hyperbolic tangent. More...
static double | arcth (double x)
| Inverse hyperbolic cotangent. More...
static bool | CheckFactorialsArray ()
| Tests ehether the factoirals in the hard-coded array (factorials64) of factorials are correct; Throws ArgumentException if any of them is incorrect. More...
static void | TestFactorials ()
| Writes to the console all factorials that can be calculatet. More...
static void | TestFactorials (int max)
| Writes to the console the first n factorials. More...
static long | fac (int factor)
| Returns factorial of the specified number. More...
static long | facCalculated (long n)
| Returns factorial of the specified number - less efficient approac, but does not rely on hard coded array. More...
static long | fallingPower (long n, long p)
| Calculates and returns the falling power of the specified number. More...
static long | binomial (long n, long k)
| Returns binomial coefficient n over k . More...
static void | TestBinomialCoefficients ()
| Writes the first few binomial coefficients to the console. More...
static void | TestBinomialCoefficients (int nMax)
| Writes binomial coefficients up to the specified number to the console. More...
static double | Mean (ICollection< double > sample)
| Returns mean value of the specified sample. More...
static double | Mean (IVector sample)
| Returns mean value of the specified sample. More...
static double | Average (ICollection< double > sample)
| Returns mean value of the specified sample. More...
static double | Average (IVector sample)
| Returns mean value of the specified sample. More...
static double | StandardDeviation (ICollection< double > sample)
| Returns estimation of the standard deviation of a random value based on the specified sample. More...
static double | StandardDeviation (IVector sample)
| Returns estimation of the standard deviation of a random value based on the specified sample. More...

## Properties
static double | E`[get]`
| Natural logarithmic base. More...
static double | Pi`[get]`
| Ratio of the circumference of a circle to its diameter. More...
static double | Zero`[get]`
| Zero (value 0.0). More...
static double | One`[get]`
| One (value 1.0). More...
Properties inherited from IG.Num.M
static double | e`[get]`
| Natural logarithmic base. More...
static double | pi`[get]`
| Ratio of the circumference of a circle to its diameter. More...
static double | zero`[get]`
| Zero (value 0.0). More...
static double | one`[get]`
| One (value 1.0). More...

## Detailed Description

Defines some mathematical functions to be used in derived classes. In addition to functions defined in the M class, functions are defined under other names, and some additional functions are also defined.

* Standard mathematical functions and constants with short names are implemented, e.g. sin() instesd of Math.Sin().

** These functions are static such that they can be used out of the derived classes, too.

*** In particular, some script classes derive from this one, in order to use simple-named mathematical functions.

** Some functions are defined with several names, in order to reduce probability of errors in scripts.

## Member Function Documentation

static double IG.Num.MExt.Abs | ( | double | a | ) |
| inline static

Absolute value.

static double IG.Num.MExt.Sign | ( | double | a | ) |
| inline static

Returns a value indicating the sign of a number.

static double IG.Num.MExt.sgn | ( | double | a | ) |
| inline static

Returns a value indicating the sign of a number.

static double IG.Num.MExt.Ceiling | ( | double | a | ) |
| inline static

Returns the smallest integral value that is greater than or equal to the specified decimal number.

static double IG.Num.MExt.ceiling | ( | double | a | ) |
| inline static

Returns the smallest integral value that is greater than or equal to the specified decimal number.

static double IG.Num.MExt.Floor | ( | double | a | ) |
| inline static

Returns the largest integer less than or equal to the specified number.

static double IG.Num.MExt.Truncate | ( | double | a | ) |
| inline static

Calculates the integral part of a specified double-precision floating-point number.

static double IG.Num.MExt.truncate | ( | double | a | ) |
| inline static

Calculates the integral part of a specified number.

static double IG.Num.MExt.Min | ( | double | a,
|  | double | b
| ) |  |
| inline static

Smallest of two numbers.

static double IG.Num.MExt.Max | ( | double | a,
|  | double | b
| ) |  |
| inline static

Largest of two numbers.

static double IG.Num.MExt.Min | ( | double | a,
|  | double | b,
|  | double | c
| ) |  |
| inline static

Smallest of three numbers.

static double IG.Num.MExt.Max | ( | double | a,
|  | double | b,
|  | double | c
| ) |  |
| inline static

Largest of three numbers.

static double IG.Num.MExt.Min | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d
| ) |  |
| inline static

Smallest of four numbers.

static double IG.Num.MExt.Max | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d
| ) |  |
| inline static

Largest of four numbers.

static double IG.Num.MExt.Min | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | e
| ) |  |
| inline static

Smallest of five numbers.

static double IG.Num.MExt.Max | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | e
| ) |  |
| inline static

Largest of five numbers.

static double IG.Num.MExt.Min | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | e,
|  | double | f
| ) |  |
| inline static

Smallest of six numbers.

static double IG.Num.MExt.Max | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d,
|  | double | e,
|  | double | f
| ) |  |
| inline static

Largest of six numbers.

static double IG.Num.MExt.Min | ( | params double[] | numbers | ) |
| inline static

Minimal of the specified values.

static double IG.Num.MExt.Max | ( | params double[] | numbers | ) |
| inline static

Maximal of the specified values.

static double IG.Num.MExt.Sum | ( | params double[] | numbers | ) |
| inline static

Sum of the specified values.

static double IG.Num.MExt.Product | ( | params double[] | numbers | ) |
| inline static

Product of the specified values.

static double IG.Num.MExt.product | ( | params double[] | numbers | ) |
| inline static

Product of the specified values.

static double IG.Num.MExt.Pow | ( | double | a,
|  | double | b
| ) |  |
| inline static

Returns a specified number raised to the specified power.

static double IG.Num.MExt.Sqr | ( | double | a | ) |
| inline static

Returns the square of a specified number.

static double IG.Num.MExt.Cube | ( | double | a | ) |
| inline static

Returns the square of a specified number.

static double IG.Num.MExt.Pow2 | ( | double | x | ) |
| inline static

Square.

static double IG.Num.MExt.Pow3 | ( | double | x | ) |
| inline static

3rd power.

static double IG.Num.MExt.Pow4 | ( | double | x | ) |
| inline static

4th power.

static double IG.Num.MExt.Pow5 | ( | double | x | ) |
| inline static

5th power.

static double IG.Num.MExt.Pow6 | ( | double | x | ) |
| inline static

6th power.

static double IG.Num.MExt.Sqrt | ( | double | a | ) |
| inline static

Returns the square root of a specified number.

static double IG.Num.MExt.Root2 | ( | double | a | ) |
| inline static

Returns the square root of a specified number.

static double IG.Num.MExt.Root3 | ( | double | a | ) |
| inline static

Returns the cubic root of a specified number.

static double IG.Num.MExt.Rand | ( |  | ) |
| inline static

Returns a uniformly distributed random number greater than or equal to 0.0, and less or equal than 1.0.

References IG.Num.RandomGenerator.Global, and IG.Num.IRandomGenerator.NextDoubleInclusive().

static double IG.Num.MExt.Rand | ( | double | min,
|  | double | max
| ) |  |
| inline static

Returns a uniformly distributed random number greater than or equal to min, and less or equal than max.

References IG.Num.RandomGenerator.Global, and IG.Num.IRandomGenerator.NextDoubleInclusive().

static double IG.Num.MExt.RandGauss | ( | double | mean,
|  | double | standardDeviation
| ) |  |
| inline static

Returns a Gaussian distributed random number with the specified mean and standard deviation.

Parameters

  mean | Mean value of the distribution.
  standardDeviation | Standard deviation of the distribution.

References IG.Num.RandomGaussian.Global, and IG.Num.RandomGaussian.NextGaussian().

static double IG.Num.MExt.Exp | ( | double | a | ) |
| inline static

Returns e raised to the specified power.

static double IG.Num.MExt.Log | ( | double | a | ) |
| inline static

Returns the natural (base e) logarithm of a specified number.

static double IG.Num.MExt.Log10 | ( | double | a | ) |
| inline static

Returns the base 10 logarithm of a specified number.

static double IG.Num.MExt.Log2 | ( | double | a | ) |
| inline static

Returns the base 2 logarithm of a specified number.

static double IG.Num.MExt.Log | ( | double | a,
|  | double | logBase
| ) |  |
| inline static

Returns the logarithm of a specified number in a specified base.

Parameters

  a | Number whose logarithm is returned.
  logBase | Base of the logarithm.

static double IG.Num.MExt.Degrees | ( | double | x | ) |
| inline static

Converts angle in radians to angle in degrees and returns it.

static double IG.Num.MExt.Radians | ( | double | x | ) |
| inline static

Converts angle in degrees to angle in radians and returns it.

static double IG.Num.MExt.Sin | ( | double | a | ) |
| inline static

Returns the sine of the specified angle.

static double IG.Num.MExt.Cos | ( | double | a | ) |
| inline static

Returns the cosine of the specified angle.

static double IG.Num.MExt.Tan | ( | double | a | ) |
| inline static

Returns the tangent of the specified angle.

static double IG.Num.MExt.tan | ( | double | a | ) |
| inline static

Returns the tangent of the specified angle.

static double IG.Num.MExt.Cot | ( | double | x | ) |
| inline static

Returns cotangent of the specified angle.

static double IG.Num.MExt.Acos | ( | double | a | ) |
| inline static

Returns the angle whose cosine is the specified number.

static double IG.Num.MExt.acos | ( | double | a | ) |
| inline static

Returns the angle whose cosine is the specified number.

static double IG.Num.MExt.Asin | ( | double | a | ) |
| inline static

Returns the angle whose sine is the specified number.

static double IG.Num.MExt.asin | ( | double | a | ) |
| inline static

Returns the angle whose sine is the specified number.

static double IG.Num.MExt.Atan | ( | double | a | ) |
| inline static

Returns the angle whose tangent is the specified number.

static double IG.Num.MExt.atan | ( | double | a | ) |
| inline static

Returns the angle whose tangent is the specified number.

static double IG.Num.MExt.arctan | ( | double | a | ) |
| inline static

Returns the angle whose tangent is the specified number.

static double IG.Num.MExt.Acot | ( | double | x | ) |
| inline static

Arc cotangent, inverse of 1/tan(x).

static double IG.Num.MExt.acot | ( | double | x | ) |
| inline static

Arc cotangent, inverse of 1/tan(x).

static double IG.Num.MExt.ArcCot | ( | double | x | ) |
| inline static

Arc cotangent, inverse of 1/tan(x).

static double IG.Num.MExt.arccot | ( | double | x | ) |
| inline static

Arc cotangent, inverse of 1/tan(x).

static double IG.Num.MExt.Atan2 | ( | double | a,
|  | double | b
| ) |  |
| inline static

Returns the angle whose tangent is the quotient of two specified numbers.

static double IG.Num.MExt.atan2 | ( | double | a,
|  | double | b
| ) |  |
| inline static

Returns the angle whose tangent is the quotient of two specified numbers.

static double IG.Num.MExt.arctan2 | ( | double | a,
|  | double | b
| ) |  |
| inline static

Returns the angle whose tangent is the quotient of two specified numbers.

static double IG.Num.MExt.Cosh | ( | double | a | ) |
| inline static

Returns the hyperbolic cosine of the specified angle.

static double IG.Num.MExt.cosh | ( | double | a | ) |
| inline static

Returns the hyperbolic cosine of the specified angle.

static double IG.Num.MExt.Tanh | ( | double | a | ) |
| inline static

Returns the hyperbolic tangent of the specified angle.

static double IG.Num.MExt.tanh | ( | double | a | ) |
| inline static

Returns the hyperbolic tangent of the specified angle.

static double IG.Num.MExt.Coth | ( | double | x | ) |
| inline static

Hyperblic cotangent, 1/Math.Tanh.

static double IG.Num.MExt.coth | ( | double | x | ) |
| inline static

Hyperblic cotangent, 1/Math.Tanh.

static double IG.Num.MExt.Arsinh | ( | double | x | ) |
| inline static

Inverse hyperbolic sine.

static double IG.Num.MExt.Arcosh | ( | double | x | ) |
| inline static

Inverse hyperbolic cosine.

static double IG.Num.MExt.Artanh | ( | double | x | ) |
| inline static

Inverse hyperbolic tangent.

static double IG.Num.MExt.Arcoth | ( | double | x | ) |
| inline static

Inverse hyperbolic cotangent.

static long IG.Num.MExt.Factorial | ( | int | factor | ) |
| inline static

Returns factorial of the specified number.

static long IG.Num.MExt.factorial | ( | int | factor | ) |
| inline static

Returns factorial of the specified number.

static long IG.Num.MExt.BinomialCoefficient | ( | long | n,
|  | long | k
| ) |  |
| inline static

Returns binomial coefficient n over k .

Parameters

  n |
  k |

## Property Documentation

double IG.Num.MExt.E
| static get

Natural logarithmic base.

double IG.Num.MExt.Pi
| static get

Ratio of the circumference of a circle to its diameter.

double IG.Num.MExt.Zero
| static get

Zero (value 0.0).

double IG.Num.MExt.One
| static get

One (value 1.0).

The documentation for this class was generated from the following file:

- igbase/utilities/UtilMath.cs